#pragma once
#include <queue>
#include "AutoLock.h"
#include "SingletonT.h"
#include <ftlBase.h>
#include <ftlThread.h>

typedef struct _tagUSERIMAGEINFO
{
	CString strUserId;
	CString strUserImageURL;
	bool operator ==  (const _tagUSERIMAGEINFO& rhs) const
	{
		if(strUserId == rhs.strUserId && strUserImageURL == rhs.strUserImageURL)
		{
			return true;
		}

		return false;
	}

}USERIMAGEINFO, *PUSERIMAGEINFO;

class IUserImageActorObserver
{
public:
	virtual ~IUserImageActorObserver(){}
	virtual void OnUserImageActor_OnResponseUserImageInfo(CString strUserId) = 0;
};

class CUserImageActor;
class CNPVPhotoCalcRect;

struct UserImageRequstInfo
{
    DWORD nLastRequestTime;
};


class CUserImageHandler
{
public:
	CUserImageHandler(CUserImageActor* pActor);
	virtual ~CUserImageHandler(void);
	void AddRequest(const USERIMAGEINFO& UserImageInfo);
	void WaitThreadExit();
	//void NotifyHandler();
private:
	
	//void Run();
	void OnSingleHandled(const USERIMAGEINFO& UserImageInfo);
	
	static UINT _stdcall DownLoadThread(LPVOID lpParam);
    UINT _InnerDownLoadThreadProc();
	BOOL DownLoadUserImage(const USERIMAGEINFO& UserImageInfo, CString& strTmpFileName);
	BOOL ScaleAndCropUserImage(const CString& strUserId, const CString& strSrcFileName, const CString& strDstFileName);  //NTALKCL-597
	//std::list<USERIMAGEINFO> m_listUserImageInfo;
	
    FTL::CFProducerResumerQueue<USERIMAGEINFO> m_WaitRequestUserImageInfo;

	//bool m_bHandling;
	CrSectionEx m_CSUserList;
	CrSectionEx m_CSHandling;
	CrSectionEx m_CSHandledUser;
	CUserImageActor* m_pActor;
    CNPVPhotoCalcRect* m_pWidthPhotoCalcRect, *m_pHeightPhotoCalcRect;
	HANDLE		m_hThreadHandle;
	//HANDLE		m_hRequestEvent;
	volatile bool		m_bThreadWorking;
};
class CUserImageActor 
	: public CSingletonT<CUserImageActor>,
	  public IGTMessengerActorEvent
{
public:
	CUserImageActor(void);
	virtual ~CUserImageActor(void);
public:
	bool RegisterObserver(IUserImageActorObserver* pObserver);
	void UnRegisterObserver(IUserImageActorObserver* pObserver);

	void RequestUserImages(const std::list<std::wstring>& listUserId);
    bool IsUserImageExist(const wstring& strUserId);
    void DeleteOldProfileImage();

	CString GetLastestHandledUserId();
	void OnGetUserImageInfo(CString strUserId);
	//void HandleNextUserImage();
	virtual bool OnGTMessengerActor_ResponseUserImage(IGTMessengerActor *pActor, const vector<GT_USER_IMAGE_RESULT_DATA>& sData);
	//virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);
	CUserImageHandler& GetUserImageHandler();
private:
    BOOL _CheckNeedRequestImage(const CString& strUserId);

	CUserImageHandler m_UserImageHander;
	vector<IUserImageActorObserver*> m_vecObservers;
	CrSectionEx m_CSObserver;

    CrSectionEx m_CSUserIdList; //lock for userInfo -- m_listUserId and m_requestInfos
    std::list<CString>	m_listUserId;

    //remain last request time -- fix old bug: will always request the user's image if he has no image on the web
    typedef std::map<CString, UserImageRequstInfo>  RequestInfoContainer;
    RequestInfoContainer    m_requestInfos;
};
